--- spice-0.12.2/server/reds.c.orig	2013-01-29 19:46:31.951152117 +1100
+++ spice-0.12.2/server/reds.c	2013-01-29 19:48:30.832946666 +1100
@@ -47,8 +47,6 @@
 #include <sasl/sasl.h>
 #endif
 
-#include <glib.h>
-
 #include <spice/protocol.h>
 #include <spice/vd_agent.h>
 #include <spice/stats.h>
@@ -354,7 +352,7 @@
     spice_assert(!(node->flags & SPICE_STAT_NODE_FLAG_ENABLED));
     node->value = 0;
     node->flags = SPICE_STAT_NODE_FLAG_ENABLED | (visible ? SPICE_STAT_NODE_FLAG_VISIBLE : 0);
-    g_strlcpy(node->name, name, sizeof(node->name));
+    strncpy(node->name, name, sizeof(node->name));
     insert_stat_node(parent, ref);
     pthread_mutex_unlock(&reds->stat_lock);
     return ref;
@@ -3984,7 +3982,7 @@
 SPICE_GNUC_VISIBLE void spice_server_set_addr(SpiceServer *s, const char *addr, int flags)
 {
     spice_assert(reds == s);
-    g_strlcpy(spice_addr, addr, sizeof(spice_addr));
+    strncpy(spice_addr, addr, sizeof(spice_addr));
     if (flags & SPICE_ADDR_FLAG_IPV4_ONLY) {
         spice_family = PF_INET;
     }
@@ -4075,7 +4073,7 @@
         taTicket.expiration_time = now + lifetime;
     }
     if (passwd != NULL) {
-        g_strlcpy(taTicket.password, passwd, sizeof(taTicket.password));
+        strncpy(taTicket.password, passwd, sizeof(taTicket.password));
     } else {
         memset(taTicket.password, 0, sizeof(taTicket.password));
         taTicket.expiration_time = 0;
@@ -4099,23 +4097,23 @@
     memset(&ssl_parameters, 0, sizeof(ssl_parameters));
 
     spice_secure_port = port;
-    g_strlcpy(ssl_parameters.ca_certificate_file, ca_cert_file,
+    strncpy(ssl_parameters.ca_certificate_file, ca_cert_file,
               sizeof(ssl_parameters.ca_certificate_file));
-    g_strlcpy(ssl_parameters.certs_file, certs_file,
+    strncpy(ssl_parameters.certs_file, certs_file,
               sizeof(ssl_parameters.certs_file));
-    g_strlcpy(ssl_parameters.private_key_file, private_key_file,
+    strncpy(ssl_parameters.private_key_file, private_key_file,
               sizeof(ssl_parameters.private_key_file));
 
     if (key_passwd) {
-        g_strlcpy(ssl_parameters.keyfile_password, key_passwd,
+        strncpy(ssl_parameters.keyfile_password, key_passwd,
                   sizeof(ssl_parameters.keyfile_password));
     }
     if (ciphersuite) {
-        g_strlcpy(ssl_parameters.ciphersuite, ciphersuite,
+        strncpy(ssl_parameters.ciphersuite, ciphersuite,
                   sizeof(ssl_parameters.ciphersuite));
     }
     if (dh_key_file) {
-        g_strlcpy(ssl_parameters.dh_key_file, dh_key_file,
+        strncpy(ssl_parameters.dh_key_file, dh_key_file,
                   sizeof(ssl_parameters.dh_key_file));
     }
     return 0;
